searchData={"items":[{"type":"task","title":"mix smee_feds.data.aggregates","doc":"List metadata sources used by default federations","ref":"Mix.Tasks.SmeeFeds.Data.Aggregates.html"},{"type":"task","title":"mix smee_feds.data.ids","doc":"List Ids used by default federations","ref":"Mix.Tasks.SmeeFeds.Data.Ids.html"},{"type":"task","title":"mix smee_feds.data.info","doc":"List general info for default federations","ref":"Mix.Tasks.SmeeFeds.Data.Info.html"},{"type":"task","title":"mix smee_feds.data.logos","doc":"List logos of default federations","ref":"Mix.Tasks.SmeeFeds.Data.Logos.html"},{"type":"task","title":"mix smee_feds.data.mdq","doc":"List MDQ service sources used by default federations","ref":"Mix.Tasks.SmeeFeds.Data.Mdq.html"},{"type":"task","title":"mix smee_feds.data.names","doc":"List general info for default federations","ref":"Mix.Tasks.SmeeFeds.Data.Names.html"},{"type":"task","title":"mix smee_feds.data.technical","doc":"List technical details of default federations","ref":"Mix.Tasks.SmeeFeds.Data.Technical.html"},{"type":"task","title":"mix smee_feds.gen.data_tests","doc":"Create a new set of compatibility tests, overwriting the existing set","ref":"Mix.Tasks.SmeeFeds.Gen.DataTests.html"},{"type":"module","title":"SmeeFeds","doc":"`SmeeFeds` is a SAML federation data management extension to [Smee](https://github.com/Digital-Identity-Labs/smee) for use in\nresearch, testing and development.\n\n[Smee](https://github.com/Digital-Identity-Labs/smee) has tools for handling the sources of SAML metadata but\nnothing to represent the publishers of metadata. SmeeFeds adds a few tools for handling federations and includes a large\ncollection of information about research and education federations.","ref":"SmeeFeds.html"},{"type":"module","title":"Features - SmeeFeds","doc":"* Easily find information on National Research and Education organisation (NREN) federations.\n* Filter and group federations by location, type, structure and tags.\n* Use federation records directly with Smee to download metadata from aggregates or MDQ servers\n* Export lists of federation information as CSV, JSON or Markdown documents\n* Manage and load federation data into your applications\n\nThe top level `SmeeFeds` module has tools for selecting individual federation details or lists of many at once.\nSmeeFeds contain more tools for handling federations, such as:\n\n* `SmeeFeds.Federation` - tools for accessing data such as metadata download URLs, contacts, homepages, and so on.\n* `SmeeFeds.Export` - convert lists of federations into JSON or CSV data for export, or simple text reports\n* `SmeeFeds.Import` - convert JSON documents into Federation lists\n* `SmeeFeds.Filter` - filter lists of federations by various criteria","ref":"SmeeFeds.html#module-features"},{"type":"module","title":"IMPORTANT DISCLAIMER AND WARNING - SmeeFeds","doc":"SmeeFeds comes with a built-in list of federations, using information gathered from various sources on the Internet.\n\nThis collection of information is example data for use by **researchers, developers and testers**.\n\n**IT IS NOT FOR USE IN PRODUCTION ENVIRONMENTS**\n\nMetadata is the bedrock of trust and information security in SAML federations. DO NOT use metadata URLs, certificates\nand certificate fingerprints to download and use metadata in live services without confirming each detail yourself.\n\nIf you must use SmeeFeds as part of a production service, then after information has been verified you can export only\nthe verified information you need as a JSON file and set it as the new default using\n`:smee_feds, :data_file` config setting in your application (if compiled) or set a list of Federations with\n`:smee_feds, :federations` at runtime.\n\nThere is absolutely no guarantee or warranty that the data in SmeeFeds is correct, and it is not supported by any of\nthe federations listed. It's totally unofficial.","ref":"SmeeFeds.html#module-important-disclaimer-and-warning"},{"type":"function","title":"SmeeFeds.autotag!/2","doc":"Accepts a list of federations, and returns a list of federations with tags automatically added.\n\nUses `Federation.autotag!/2`, and works with lists and streams.","ref":"SmeeFeds.html#autotag!/2"},{"type":"function","title":"Examples - SmeeFeds.autotag!/2","doc":"iex> tags = SmeeFeds.federations() |> SmeeFeds.autotag!() |> SmeeFeds.tags()\n    iex> \"mesh\" in tags\n    true","ref":"SmeeFeds.html#autotag!/2-examples"},{"type":"function","title":"SmeeFeds.countries/1","doc":"Lists all countries in the provided list of federations","ref":"SmeeFeds.html#countries/1"},{"type":"function","title":"Examples - SmeeFeds.countries/1","doc":"iex> SmeeFeds.federations([:ukamf, :incommon]) |> SmeeFeds.countries()","ref":"SmeeFeds.html#countries/1-examples"},{"type":"function","title":"SmeeFeds.federation/1","doc":"Finds a federation in the default database by ID and returns the full federation record.","ref":"SmeeFeds.html#federation/1"},{"type":"function","title":"Example - SmeeFeds.federation/1","doc":"iex> incommon = SmeeFeds.federation(:incommon)\n    iex> incommon.policy\n    \"https://incommon.org/about/policies/\"","ref":"SmeeFeds.html#federation/1-example"},{"type":"function","title":"SmeeFeds.federations/0","doc":"Returns a list of `SmeeFeds.Federation` structs from the default collection.\n\nReturns all known federations from the default collection.","ref":"SmeeFeds.html#federations/0"},{"type":"function","title":"Example - SmeeFeds.federations/0","doc":"iex> federations = SmeeFeds.federations()\n    iex> Enum.count(federations)\n    76","ref":"SmeeFeds.html#federations/0-example"},{"type":"function","title":"SmeeFeds.federations/1","doc":"Returns a list of the specified `SmeeFeds.Federation` structs from the default collection.","ref":"SmeeFeds.html#federations/1"},{"type":"function","title":"Example - SmeeFeds.federations/1","doc":"iex> federations = SmeeFeds.federations([:ukamf, :wayf])\n    iex> Enum.count(federations)\n    2","ref":"SmeeFeds.html#federations/1-example"},{"type":"function","title":"SmeeFeds.get/2","doc":"Finds a federation in the supplied list by ID and returns the full federation record.","ref":"SmeeFeds.html#get/2"},{"type":"function","title":"Example - SmeeFeds.get/2","doc":"iex> federations = SmeeFeds.federations()\n    iex> incommon = SmeeFeds.get(federations, :incommon)\n    iex> incommon.url\n    \"http://incommon.org/\"","ref":"SmeeFeds.html#get/2-example"},{"type":"function","title":"SmeeFeds.get_by/3","doc":"Returns a federation record if one with the specified ID is present in the list, or nil if one can't be found\n\nAvailable IDs can be found using `SmeeFeds.id_types/1`. Two are built-in: `:uri` and `:smee`. Any other\n  ID key used in the `alt_ids` part of the Federation struct can be searched.","ref":"SmeeFeds.html#get_by/3"},{"type":"function","title":"Examples - SmeeFeds.get_by/3","doc":"iex> SmeeFeds.federations() |> SmeeFeds.get_by(:uri, \"http://ukfederation.org.uk\")\n    iex> SmeeFeds.federations() |> SmeeFeds.get_by(:edugain,  \"HAKA\")","ref":"SmeeFeds.html#get_by/3-examples"},{"type":"function","title":"SmeeFeds.id_types/1","doc":"Lists all ID types in the provided list of federations, as atoms.","ref":"SmeeFeds.html#id_types/1"},{"type":"function","title":"Examples - SmeeFeds.id_types/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.id_types()\n    [:edugain, :met, :smee, :uri]","ref":"SmeeFeds.html#id_types/1-examples"},{"type":"function","title":"SmeeFeds.ids/1","doc":"Returns the ids of all federations in the provided list of federations as a list of atoms.","ref":"SmeeFeds.html#ids/1"},{"type":"function","title":"Example - SmeeFeds.ids/1","doc":"iex> ids = SmeeFeds.ids(SmeeFeds.federations())\n     iex> Enum.slice(ids, 0..3)\n     [:aaf, :aaieduhr, :aaiedumk, :aconet]","ref":"SmeeFeds.html#ids/1-example"},{"type":"function","title":"SmeeFeds.protocols/1","doc":"Lists all unique protocols in the provided list of federations, as atoms.","ref":"SmeeFeds.html#protocols/1"},{"type":"function","title":"Examples - SmeeFeds.protocols/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.protocols()\n    [:saml2]","ref":"SmeeFeds.html#protocols/1-examples"},{"type":"function","title":"SmeeFeds.publisher/2","doc":"Tries to find the federation that published the provided Smee record (source, entity or metadata)\n\nThe first matching federation record will be returned if found, or nil if no federations match.","ref":"SmeeFeds.html#publisher/2"},{"type":"function","title":"Example - SmeeFeds.publisher/2","doc":"iex> source = Smee.source(\"http://metadata.ukfederation.org.uk/ukfederation-metadata.xml\")\n    iex> federations = SmeeFeds.federations()\n    iex> federation = SmeeFeds.publisher(federations, source)\n    %SmeeFeds.Federation{id: :ukamf} = federation","ref":"SmeeFeds.html#publisher/2-example"},{"type":"function","title":"SmeeFeds.publisher?/2","doc":"Is a federation the publisher of the provided Smee Source, Metadata, or Entity?\n\nReturns true if the federation and source, metadata or entity share a URL or publisher URI, false otherwise.","ref":"SmeeFeds.html#publisher?/2"},{"type":"function","title":"Example - SmeeFeds.publisher?/2","doc":"iex> source = Smee.source(\"http://metadata.ukfederation.org.uk/ukfederation-metadata.xml\")\n    iex> federations = SmeeFeds.federations()\n    iex> federation = SmeeFeds.get(federations, :ukamf)\n    iex> SmeeFeds.publisher?(federation, source)\n    true","ref":"SmeeFeds.html#publisher?/2-example"},{"type":"function","title":"SmeeFeds.regions/1","doc":"Lists all regions in the provided list of federations","ref":"SmeeFeds.html#regions/1"},{"type":"function","title":"Examples - SmeeFeds.regions/1","doc":"iex> SmeeFeds.federations([:ukamf, :incommon]) |> SmeeFeds.regions()\n    [\"Americas\", \"Europe\"]","ref":"SmeeFeds.html#regions/1-examples"},{"type":"function","title":"SmeeFeds.structures/1","doc":"Lists all types of structures in the provided list of federations, as atoms.","ref":"SmeeFeds.html#structures/1"},{"type":"function","title":"Examples - SmeeFeds.structures/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.structures()\n    [:has, :mesh]","ref":"SmeeFeds.html#structures/1-examples"},{"type":"function","title":"SmeeFeds.sub_regions/1","doc":"Lists all sub_regions in the provided list of federations","ref":"SmeeFeds.html#sub_regions/1"},{"type":"function","title":"Examples - SmeeFeds.sub_regions/1","doc":"iex> SmeeFeds.federations([:ukamf, :incommon]) |> SmeeFeds.sub_regions()\n    [\"Northern America\", \"Northern Europe\"]","ref":"SmeeFeds.html#sub_regions/1-examples"},{"type":"function","title":"SmeeFeds.super_regions/1","doc":"Lists all super_regions in the provided list of federations","ref":"SmeeFeds.html#super_regions/1"},{"type":"function","title":"Examples - SmeeFeds.super_regions/1","doc":"iex> SmeeFeds.federations([:ukamf, :incommon]) |> SmeeFeds.super_regions()\n    [\"AMER\", \"EMEA\"]","ref":"SmeeFeds.html#super_regions/1-examples"},{"type":"function","title":"SmeeFeds.tags/1","doc":"Lists all unique tags in the provided list of federations, as atoms.","ref":"SmeeFeds.html#tags/1"},{"type":"function","title":"Examples - SmeeFeds.tags/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.tags()\n    [\"noSlow\", \"noTest\"]","ref":"SmeeFeds.html#tags/1-examples"},{"type":"function","title":"SmeeFeds.take/2","doc":"Returns a filtered list of `SmeeFeds.Federation` structs when passed a list of\n federations and federation IDs (as atoms) to select.","ref":"SmeeFeds.html#take/2"},{"type":"function","title":"Example - SmeeFeds.take/2","doc":"iex> all_federations = SmeeFeds.federations()\n    iex> my_federations = SmeeFeds.take(all_federations, [:ukamf, :switch])\n    iex> Enum.map(my_federations, fn f -> f.name end)\n    [\"SWITCHaai\", \"UK Access Management Federation\"]","ref":"SmeeFeds.html#take/2-example"},{"type":"function","title":"SmeeFeds.types/1","doc":"Lists all federation types in the provided list of federations, as atoms.","ref":"SmeeFeds.html#types/1"},{"type":"function","title":"Examples - SmeeFeds.types/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.types()\n    [:inter, :misc, :nren]","ref":"SmeeFeds.html#types/1-examples"},{"type":"function","title":"SmeeFeds.upstream/1","doc":"Lists all upstream federation IDs in the provided list of federations, as atoms.","ref":"SmeeFeds.html#upstream/1"},{"type":"function","title":"Examples - SmeeFeds.upstream/1","doc":"iex> SmeeFeds.federations() |> SmeeFeds.upstream()\n    [:edugain]\n    iex> [%SmeeFeds.Federation{id: :edugain}] =  SmeeFeds.federations |> SmeeFeds.upstream() |> SmeeFeds.federations()","ref":"SmeeFeds.html#upstream/1-examples"},{"type":"module","title":"SmeeFeds.Export","doc":"Converts lists of federations into other formats suitable for export and use in other applications.\n\nSome exports are focused on presenting the data (such as `markdown/1`, others are lossy summaries (`csv/1`) and some are\n  contain all data (`json/1`).","ref":"SmeeFeds.Export.html"},{"type":"function","title":"SmeeFeds.Export.csv/1","doc":"Creates a CSV export of the provided federations as a single string.\n\nNot all information is included - the CSV only contains ID, name, URL, countries, policy url and metadata URLs for the\n  main aggregate and MDQ service. Other information is not included.","ref":"SmeeFeds.Export.html#csv/1"},{"type":"function","title":"SmeeFeds.Export.dd_json!/1","doc":"Produces a string containing all passed federations in the JSON format used for SmeeFeds default data.\n\nThis format is best used for creating new default data sets, and is not for general purpose serialization.\n\nIt is possible to use additional lines in federation records:\n\n * `active: false` - prevents the record from loading\n * `comment: \"a comment\"` - notes that will be ignored when the data is loaded\n * `todo: \"task details\"` - developer notes that will be ignored when the data is loaded\n\nThe JSON *should* contain all federation information and can be used by SmeeFeds as a replacement for the default source of\nfederation information. Federations are stored in a map.","ref":"SmeeFeds.Export.html#dd_json!/1"},{"type":"function","title":"SmeeFeds.Export.dd_json_file!/2","doc":"Produces a string containing all passed federations in the JSON format used for SmeeFeds default data,\n  and then writes it directly to disk at the specified filename/path.\n\nThis format is best used for creating new default data sets, and is not for general purpose serialization.\n\nIt is possible to use additional lines in federation records:\n\n * `active: false` - prevents the record from loading\n * `comment: \"a comment\"` - notes that will be ignored when the data is loaded\n * `todo: \"task details\"` - developer notes that will be ignored when the data is loaded\n\nThe JSON *should* contain all federation information and can be used by SmeeFeds as a replacement for the default source of\nfederation information. Federations are stored in a map.","ref":"SmeeFeds.Export.html#dd_json_file!/2"},{"type":"function","title":"SmeeFeds.Export.json!/1","doc":"Produces a string containing all passed federations in the normal Smee JSON format.\n\nThis format is best for general-purpose serialisation of the federation records.\n\nFederations are stored as a list.","ref":"SmeeFeds.Export.html#json!/1"},{"type":"function","title":"SmeeFeds.Export.json_file!/2","doc":"Creates a file containing all passed federations in the normal Smee JSON format.\n\nThis format is best for general-purpose serialisation of the federation records.\n\nFederations are stored as a list.","ref":"SmeeFeds.Export.html#json_file!/2"},{"type":"function","title":"SmeeFeds.Export.markdown/1","doc":"Produces a simple Markdown-formatted table summarising the provided list of federations.\n\n  Not all information is included - the CSV only contains ID, name, URL, countries, policy url and metadata URLs for the\n  main aggregate and MDQ service. Other information is not included.\n\nThe Markdown output can be used with most modern markdown parsers, including Github comments.","ref":"SmeeFeds.Export.html#markdown/1"},{"type":"module","title":"SmeeFeds.Federation","doc":"Federation provides structs that represents federated metadata publishers, and some simple tools to manage the\ninformation in them.","ref":"SmeeFeds.Federation.html"},{"type":"function","title":"SmeeFeds.Federation.aggregate/1","doc":"Returns the default aggregate metadata details for the federation, or nil if none has been defined.","ref":"SmeeFeds.Federation.html#aggregate/1"},{"type":"function","title":"SmeeFeds.Federation.autotag!/2","doc":"Tags a federation record with one or more tags generated automatically from the federation's other\n  details, returning an updated Federation struct.\n\nTags will include the federation ID, type, structure, countries, source type, and so on.\n\nSources in the Federation will also be tagged, and these tags will be inherited by Metadata and Entity structs\n  derived from the Source.","ref":"SmeeFeds.Federation.html#autotag!/2"},{"type":"function","title":"SmeeFeds.Federation.contact/1","doc":"Gets the general contact information for the federation as a URL.","ref":"SmeeFeds.Federation.html#contact/1"},{"type":"function","title":"SmeeFeds.Federation.countries/1","doc":"Returns the countries associated with the federation as `Countries` structs.\n\nSee [Countries](https://hexdocs.pm/countries/api-reference.html) documentation for more information.","ref":"SmeeFeds.Federation.html#countries/1"},{"type":"function","title":"SmeeFeds.Federation.description/2","doc":"Returns a description for the federation struct, attempting to use the specified language, but returning\n  the English description if that isn't available. Nil will be returned if no suitable language can be found.","ref":"SmeeFeds.Federation.html#description/2"},{"type":"function","title":"SmeeFeds.Federation.displayname/2","doc":"Returns a displayname for the federation struct, attempting to use the specified language, but returning\n  the English displayname or name for the Federation if that isn't available.","ref":"SmeeFeds.Federation.html#displayname/2"},{"type":"function","title":"SmeeFeds.Federation.id/2","doc":"Returns an ID for the federation, of the specified type. Defaults to the main (`:smee`) ID\n\n* `:smee` - returns the main ID\n* `:uri` - returns the publishing/registration URI\n* `:uri_hash` - returns sha1 hash of the federation's URI\n\nIf other keys are available in the data they can also be specified. The example data has `:edugain` and `:met` IDs.","ref":"SmeeFeds.Federation.html#id/2"},{"type":"function","title":"SmeeFeds.Federation.mdq/1","doc":"Returns the default MDQ service for the federation, or nil if none has been defined.","ref":"SmeeFeds.Federation.html#mdq/1"},{"type":"function","title":"SmeeFeds.Federation.new/2","doc":"Creates a new Federation struct. The only requirement is a unique ID, passed as the first parameter.\n\nThe ID should be a single unique word, as an atom.\n\nOther information can be passed as an option:\n\ndefault MDQ service.\n* `autotag`: Boolean, indicates that various explicit tags and inferred tags will be added to sources. Defaults to false.\n* `contact`: general contact address for the federation, as a URL.\n* `countries`: A list of 2-letter country codes for countries the federation officially provides services for.\n* `descriptions`: Map of language codes to descriptions for the federation\n* `displaynames`: Map of language codes to displaynames for the federation\n* `interfederates`: List of IDs of other federations this federation pushes data to\n* `protocols`: List of protocols supported by the federation - defaults to :saml2\n* `logo`: URL to the logo for the federation\n* `name`: The full, official, international name of the federation\n* `policy`: URL for the federation's metadata policy documentation\n* `alt_ids`: A map of alternative IDs, as used by other services, organisations and lists\n* `sources`: Map of atom IDs and `Smee.Source` structs or maps. Use `default:` for the default aggregate, and `mdq:` for the\n  main MDQ service.\n* `structure`: Technical structure of the federation. Values are :mesh, :has, :hybrid. :Defaults to :mesh.\n* `tags`: List of tags which can be passed down to Sources, Metadata and Entities.\n* `type`: The *federation's* type. Possible values are :nren, :research, :inter, :misc, :mil, :com, :local. Defaults to :local\n* `uri`: The publisher URI of the federation\n* `url`: The URL of the federation's homepage\n\nSupported options: * `:type` - The default value is `:local`.\n\n* `:structure` - The default value is `:mesh`.\n\n* `:alt_ids` (map of `t:atom/0` keys and `t:String.t/0` values) - The default value is `%{}`.\n\n* `:descriptions` (map of `t:atom/0` keys and `t:String.t/0` values) - The default value is `%{}`.\n\n* `:displaynames` (map of `t:atom/0` keys and `t:String.t/0` values) - The default value is `%{}`.\n\n* `:logo` - The default value is `nil`.\n\n* `:autotag` (`t:boolean/0`) - The default value is `false`.\n\n* `:interfederates` - The default value is `[]`.\n\n* `:tags` - The default value is `[]`.\n\n* `:contact` (`t:String.t/0`)\n\n* `:name` (`t:String.t/0`)\n\n* `:url` (`t:String.t/0`)\n\n* `:uri` (`t:String.t/0`)\n\n* `:countries`\n\n* `:protocols`\n\n* `:policy` (`t:String.t/0`)\n\n* `:id`\n\n* `:sources` - The default value is `%{}`.\n\n\n\nSmeeFeds comes with a list of built-in federations - use `SmeeFeds.federations/0` to view them.","ref":"SmeeFeds.Federation.html#new/2"},{"type":"function","title":"SmeeFeds.Federation.policy_url/1","doc":"Returns the policy URL for the federation (if known) or nil","ref":"SmeeFeds.Federation.html#policy_url/1"},{"type":"function","title":"SmeeFeds.Federation.source/2","doc":"Returns a source with the specified source ID, or URL, or nil if one cannot be found.\n\nIDs will be unique but URLs might not be, so the first matching source will be returned.","ref":"SmeeFeds.Federation.html#source/2"},{"type":"function","title":"SmeeFeds.Federation.sources/1","doc":"Returns the sources of the federation struct, as a list of Source structs\n\nIf no sources have been defined it will return an empty list.","ref":"SmeeFeds.Federation.html#sources/1"},{"type":"function","title":"SmeeFeds.Federation.sources/2","doc":"Returns the federation with the specified Smee Source structs set as the list of sources, replacing previous sources.\n\nOnly proper Source structs will be added, everything else will be silently ignored.\n\nSources with IDs will be added with those IDs. Sources without IDs will be added with IDs like \"source0\", \"source1\", etc.\n  Sources with conflicting IDs will be overwritten by the last one in the list.","ref":"SmeeFeds.Federation.html#sources/2"},{"type":"function","title":"SmeeFeds.Federation.tag/2","doc":"Tags a federation record with one or more tags, replacing existing tags.\n\nTags are arbitrary strings.","ref":"SmeeFeds.Federation.html#tag/2"},{"type":"function","title":"SmeeFeds.Federation.tags/1","doc":"Returns the tags of the federation struct, a list of binary strings\n\nTags are arbitrary strings.","ref":"SmeeFeds.Federation.html#tags/1"},{"type":"function","title":"SmeeFeds.Federation.url/1","doc":"Returns the homepage URL for the federation, or nil.","ref":"SmeeFeds.Federation.html#url/1"},{"type":"type","title":"SmeeFeds.Federation.t/0","doc":"","ref":"SmeeFeds.Federation.html#t:t/0"},{"type":"module","title":"SmeeFeds.Filter","doc":"Processes a list or stream of federations to include or exclude federation structs matching the specified criteria.\n\nBy default these functions include matching federations and exclude those that do not match, but this an be reversed.\nFor example, by default `SmeeFeds.Filter.eu/2` will exclude entities that are not in the EU, but by specifying `false` as the third\nparameter the filter will be inverted and exclude entities that are in the EU.","ref":"SmeeFeds.Filter.html"},{"type":"function","title":"SmeeFeds.Filter.aggregate/2","doc":"Filter a list or stream of federations by whether they provide a metadata aggregate\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#aggregate/2"},{"type":"function","title":"SmeeFeds.Filter.eu/2","doc":"Filter a list or stream of federations so that only those in the EU remain.\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#eu/2"},{"type":"function","title":"SmeeFeds.Filter.id_type/3","doc":"Filter a list or stream of federations so that only those with an ID of the specified type remain.\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#id_type/3"},{"type":"function","title":"SmeeFeds.Filter.ids/3","doc":"Filter a list or stream of federations so that only those with matching IDs remain\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#ids/3"},{"type":"function","title":"SmeeFeds.Filter.interfederates/3","doc":"Filter a list or stream of federations by upstream federation\n\nSpecify the upstream federation by passing its ID as an atom.\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#interfederates/3"},{"type":"function","title":"SmeeFeds.Filter.mdq/2","doc":"Filter a list or stream of federations by whether or not they provice an MDQ service\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#mdq/2"},{"type":"function","title":"SmeeFeds.Filter.protocol/3","doc":"Filter a list or stream of federations by federation protocol\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#protocol/3"},{"type":"function","title":"SmeeFeds.Filter.region/3","doc":"Filter a list or stream of federations so that only those in the specified region remain.\n\nThe list of available regions can be seen by calling `SmeeFeds.regions()`\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#region/3"},{"type":"function","title":"SmeeFeds.Filter.structure/3","doc":"Filter a list or stream of federations by federation structure\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#structure/3"},{"type":"function","title":"SmeeFeds.Filter.sub_region/3","doc":"Filter a list or stream of federations so that only those in the specified sub_region remain.\n\nThe list of available regions can be seen by calling `SmeeFeds.sub_regions()`\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#sub_region/3"},{"type":"function","title":"SmeeFeds.Filter.super_region/3","doc":"Filter a list or stream of federations so that only those in the specified super_region remain.\n\nThe list of available regions can be seen by calling `SmeeFeds.super_regions()`\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#super_region/3"},{"type":"function","title":"SmeeFeds.Filter.tag/3","doc":"Filter a list or stream of federations by federation tag\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#tag/3"},{"type":"function","title":"SmeeFeds.Filter.type/3","doc":"Filter a list or stream of federations by federation type\n\nThe filter is positive by default but can be inverted by specifying `false`","ref":"SmeeFeds.Filter.html#type/3"},{"type":"module","title":"SmeeFeds.Import","doc":"Converts serialised federation data into the Federation structs used by SmeeFeds.\n\nPlease see the `SmeeFeds.Export` module too.","ref":"SmeeFeds.Import.html"},{"type":"function","title":"SmeeFeds.Import.dd_json!/2","doc":"Parses the JSON string and returns a map of Federations.\n\nThis format is intended for use inside `SmeeFeds` as the default federation data. In most cases it is better\n  to use `Import.json!` instead.\n\nThe JSON format is expected to be the same as that as `SmeeFeds.Export.dd_json_file!` and  `SmeeFeds.Export.dd_json!`","ref":"SmeeFeds.Import.html#dd_json!/2"},{"type":"function","title":"SmeeFeds.Import.dd_json_file!/2","doc":"Reads the specified filename and returns a map of Federations\n\nThis format is intended for use inside `SmeeFeds` as the default federation data. In most cases it is better\n  to use `SmeeFeds.Import.json_file!` instead.\n\nThe JSON format is expected to be the same as that as `SmeeFeds.Export.dd_json_file!` and  `SmeeFeds.Export.dd_json!`","ref":"SmeeFeds.Import.html#dd_json_file!/2"},{"type":"function","title":"SmeeFeds.Import.json!/1","doc":"Parses the JSON string and returns a list of Federations.\n\nThe JSON format is expected to be the same as that as `Export.json_file!` and  `Export.json!`","ref":"SmeeFeds.Import.html#json!/1"},{"type":"function","title":"SmeeFeds.Import.json_file!/1","doc":"Reads the specified filename and returns a list of Federations\n\nThe JSON format is expected to be the same as that as `SmeeFeds.Export.json_file!` and  `SmeeFeds.Export.json!`","ref":"SmeeFeds.Import.html#json_file!/1"},{"type":"extras","title":"SmeeFeds","doc":"# SmeeFeds\n\n`SmeeFeds` is a SAML federation data management extension to [Smee](https://github.com/Digital-Identity-Labs/smee) for use in\nresearch, testing and development.\n\n[Smee](https://github.com/Digital-Identity-Labs/smee) has tools for handling the sources of SAML metadata but \nnothing to represent the publishers of metadata. SmeeFeds adds a few tools for handling federations and includes a large\ncollection of information about research and education federations.\n\n[![Hex pm](http://img.shields.io/hexpm/v/smee_feds.svg?style=flat)](https://hex.pm/packages/smee_feds)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](http://hexdocs.pm/smee_feds/)\n![Github Elixir CI](https://github.com/Digital-Identity-Labs/smee_feds/workflows/Elixir%20CI/badge.svg)\n\n[![Run in Livebook](https://livebook.dev/badge/v1/blue.svg)](https://livebook.dev/run?url=https%3A%2F%2Fraw.githubusercontent.com%2FDigital-Identity-Labs%2Fsmee_feds%2Fmain%2Fsmee_feds_notebook.livemd)","ref":"readme.html"},{"type":"extras","title":"Features - SmeeFeds","doc":"* Easily find information on National Research and Education organisation (NREN) federations.\n* Filter and group federations by location, type, structure and tags.\n* Use federation records directly with Smee to download metadata from aggregates or MDQ servers\n* Export lists of federation information as CSV, JSON or Markdown documents\n* Manage and load federation data into your applications\n* Includes over 70 research and education federations' details for use in tests\n\nThe top level `SmeeFeds` module has tools for selecting individual federation details or lists of many at once.\nSmeeFeds contain more tools for handling federations, such as:\n\n* `SmeeFeds.Federation` - tools for accessing data such as metadata download URLs, contacts, homepages, and so on.\n* `SmeeFeds.Export` - convert lists of federations into JSON or CSV data for export, or simple text reports\n* `SmeeFeds.Import` - convert JSON documents into Federation lists\n* `SmeeFeds.Filter` - filter lists of federations by various criteria","ref":"readme.html#features"},{"type":"extras","title":"IMPORTANT DISCLAIMER AND WARNING - SmeeFeds","doc":"SmeeFeds comes with a built-in list of federations, using information gathered from various sources on the Internet.\n\nThis collection of information is example data for use by **researchers, developers and testers**. \n\n**IT IS NOT FOR USE IN PRODUCTION ENVIRONMENTS**\n\nMetadata is the bedrock of trust and information security in SAML federations. DO NOT use metadata URLs, certificates \nand certificate fingerprints to download and use metadata in live services without confirming each detail yourself.\n\nIf you must use SmeeFeds as part of a production service, then after information has been verified you can export only\nthe verified information you need as a JSON file and set it as the new default using \n`:smee_feds, :data_file` config setting in your application (if compiled) or set a list of Federations with \n`:smee_feds, :federations` at runtime.\n\nThere is absolutely no guarantee or warranty that the data in SmeeFeds is correct, and it is not supported by any of \nthe federations listed. It's totally unofficial.","ref":"readme.html#important-disclaimer-and-warning"},{"type":"extras","title":"Examples - SmeeFeds","doc":"#","ref":"readme.html#examples"},{"type":"extras","title":"Using with Smee to download UK Access Management Federation metadata, pick a random entity and get its XML - SmeeFeds","doc":"Useful for testing as there's no need to remember or look up metadata details.\n\n```elixir\nrandom_xml = SmeeFeds.federation(:ukamf)\n|> SmeeFeds.Federation.aggregate()\n|> Smee.fetch!()\n|> Smee.Metadata.random_entity()\n|> Smee.Entity.xml()\n```\n\n#","ref":"readme.html#using-with-smee-to-download-uk-access-management-federation-metadata-pick-a-random-entity-and-get-its-xml"},{"type":"extras","title":"Finding an MDQ service - SmeeFeds","doc":"Very few MDQ services are present in the data, but they can be used as follows:\n\n```elixir\ncern_idp = SmeeFeds.federation(:incommon)\n|> SmeeFeds.Federation.mdq()\n|> Smee.MDQ.lookup!(\"https://cern.ch/login\")\n```\n\nYou can list the IDs of all federations that have an MDQ service using a filter:\n\n```elixir\nSmeeFeds.federations()\n|> SmeeFeds.Filter.mdq()\n|> SmeeFeds.ids()\n```\n\n#","ref":"readme.html#finding-an-mdq-service"},{"type":"extras","title":"Getting a list of specific federations and writing their details to disk as a JSON file or CSV - SmeeFeds","doc":"The JSON file can be used a new default set of federations. \n\n```elixir\nSmeeFeds.federations([:wayf, :haka, :dfnaai, :swamid])\n|> SmeeFeds.Export.json_file!(\"my_feds.json\")\n```\n\nThe CSV export is a simpler, lossy summary.\n```elixir\ncsv = SmeeFeds.federations([:wayf, :haka, :dfnaai, :swamid])\n       |> SmeeFeds.Export.csv()\n\nFile.write!(\"my_feds.csv\", csv)\n```\n\n#","ref":"readme.html#getting-a-list-of-specific-federations-and-writing-their-details-to-disk-as-a-json-file-or-csv"},{"type":"extras","title":"Defining your own lists of federations - SmeeFeds","doc":"```elixir\nmy_feds = [\nSmeeFeds.Federation.new(:fed1, name: \"Example 1\", sources: [Smee.Source.new(\"https://example.com/metadata\")]),\nSmeeFeds.Federation.new(:fed2, name: \"Example 2\", sources: [Smee.Source.new(\"https://example.edu/metadata\")])\n] \n ```\n\n#","ref":"readme.html#defining-your-own-lists-of-federations"},{"type":"extras","title":"Filtering lists of federations - SmeeFeds","doc":"Listing all known federations, then selecting those in the EU, and listing their unique IDs\n\n```elixir\nSmeeFeds.federations()\n|> SmeeFeds.Filter.eu()\n|> SmeeFeds.ids()\n```\n\nFinding all hub-and-spoke networks with an MDQ service and returning their names\n\n```elixir\nSmeeFeds.federations()\n|> SmeeFeds.Filter.structure(:has)\n|> SmeeFeds.Filter.mdq()\n|> Enum.map(fn f -> f.name end)\n\n\n```\n\n#","ref":"readme.html#filtering-lists-of-federations"},{"type":"extras","title":"Opening all homepages - SmeeFeds","doc":"Perhaps you want to check the homepages of all federations in a collection (this example works on a Mac)\n\n```elixir\nSmeeFeds.federations()\n|> Enum.each(fn f -> if f.url, do: System.cmd(\"open\", [f.url]) end)\n```\n\nOr see all logos\n\n```elixir\nSmeeFeds.federations()\n|> Enum.each(fn f -> if f.logo, do: System.cmd(\"open\", [f.logo]) end)\n```\n\n#","ref":"readme.html#opening-all-homepages"},{"type":"extras","title":"Information about lists of federations - SmeeFeds","doc":"The top level SmeeFeds module can return unique values present in collections. For example, all tags:\n\n```elixir\ntags = SmeeFeds.federations()\n|> SmeeFeds.tags()\n```\n\nor structure types\n\n```elixir\nstructures = SmeeFeds.federations()\n|> SmeeFeds.structures()\n```","ref":"readme.html#information-about-lists-of-federations"},{"type":"extras","title":"Installation - SmeeFeds","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `smee_feds` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:smee_feds, \"~> 0.3.1\"}\n  ]\nend\n```\n\nSmeeFeds requires [Smee](https://github.com/Digital-Identity-Labs/smee), which has its own unusual requirements, so\nplease make sure you read the documentation for installing Smee before using SmeeFeds.","ref":"readme.html#installation"},{"type":"extras","title":"Uses - SmeeFeds","doc":"The main reason SmeeFeds was hurriedly put together on a Sunday afternoon is that I needed to test `Smee` with a variety\nof federations, and my various scattered notes and comments and tests with URLs and certificate fingerprints were becoming a nuisance.\nThe original focus was on the default data, as a convenient resource for testing.\n\nIt's possibly an over-engineered solution to that problem but it was fun.\n\nOver time the federation collection features of SmeeFeds have become useful in other projects as a way to load sources\nof metadata in a consistent way, so these have been expanded and strengthened.","ref":"readme.html#uses"},{"type":"extras","title":"Alternatives and Sources - SmeeFeds","doc":"The best source of this information is the websites of the federations themselves, and the best way to find those\nwebsites is to read the websites of Edugain and REFEDS.\n\n* [Edugain](https://edugain.org/) \"eduGAIN comprises over 80 participant federations connecting more than 8,000 Identity and Service Providers\" \n* [REFEDS](https://refeds.org/) \"REFEDS is a community of practitioners actively engaged in access and identity work within their home countries and supportive of standards-compliant developments to enhance international collaboration\"\n* [MET](https://met.refeds.org/) \"Metadata explorer tool is a fast way to find federations, entities, and their relations through entity/federation metadata file information.\"","ref":"readme.html#alternatives-and-sources"},{"type":"extras","title":"Documentation - SmeeFeds","doc":"Documentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#documentation"},{"type":"extras","title":"Contributing - SmeeFeds","doc":"You can request new features by creating an [issue](https://github.com/Digital-Identity-Labs/smee_feds/issues),\nor submit a [pull request](https://github.com/Digital-Identity-Labs/smee_feds/pulls) with your contribution.\n\nIf you are comfortable working with Python but Smee's Elixir code is unfamiliar then this blog post may help: \n[Elixir For Humans Who Know Python](https://hibox.live/elixir-for-humans-who-know-python)","ref":"readme.html#contributing"},{"type":"extras","title":"Copyright and License - SmeeFeds","doc":"Copyright (c) 2023, 2024 Digital Identity Ltd, UK\n\nSmeeFeds is Apache 2.0 licensed.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Disclaimer - SmeeFeds","doc":"Smee is not endorsed by The Shibboleth Foundation or any of the NREN's described within.\nThe API will definitely change considerably in the first few releases after 0.1.0 - it is not stable!","ref":"readme.html#disclaimer"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown"}